Index: drivers/s390/block/dasd_int.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/s390/block/dasd_int.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/s390/block/dasd_int.h	22 Jul 2004 19:49:59 -0000	1.1
+++ drivers/s390/block/dasd_int.h	4 Aug 2004 01:29:28 -0000	1.2
@@ -1,9 +1,12 @@
 /* 
- * File...........: linux/drivers/s390/block/dasd.c
+ * File...........: linux/drivers/s390/block/dasd_int.h
  * Author(s)......: Holger Smolinski <Holger.Smolinski@de.ibm.com>
+ *                  Horst Hummel <Horst.Hummel@de.ibm.com> 
  * Bugreports.to..: <Linux390@de.ibm.com>
  * (C) IBM Corporation, IBM Deutschland Entwicklung GmbH, 1999,2000
  *
+ * $Revision: 1.2 $
+ *
  * History of changes (starts July 2000)
  * 02/01/01 added dynamic registration of ioctls
  */
@@ -11,8 +14,6 @@
 #ifndef DASD_INT_H
 #define DASD_INT_H
 
-#define DASD_API_VERSION 0
-
 #include <asm/dasd.h>
 
 #define CONFIG_DASD_DYNAMIC
@@ -28,14 +29,19 @@
 #define DASD_FORMAT_INTENS_WRITE_RECZERO 0x01
 #define DASD_FORMAT_INTENS_WRITE_HOMEADR 0x02
 
-#define DASD_STATE_DEL   -1
-#define DASD_STATE_NEW    0
-#define DASD_STATE_KNOWN  1
-#define DASD_STATE_ACCEPT 2
-#define DASD_STATE_INIT   3
-#define DASD_STATE_READY  4
-#define DASD_STATE_ONLINE 5
-
+#define DASD_STATE_DEL   -1     /* "unknown" */
+#define DASD_STATE_NEW    0     /* memory for dasd_device_t and lowmem ccw/idals allocated */  
+#define DASD_STATE_BOXED  1     /* boxed dasd could not be analysed "plugged" */
+#define DASD_STATE_KNOWN  2     /* major_info/devinfo/discipline/devfs-'device'/gendisk - "detected" */
+#define DASD_STATE_ACCEPT 3     /* irq requested - "accepted" */
+#define DASD_STATE_INIT   4     /* init_cqr started - "busy" */
+#define DASD_STATE_READY  5     /* init finished  - "fenced(plugged)" */
+#define DASD_STATE_ONLINE 6     /* unplugged "active" */
+
+#define DASD_HOTPLUG_EVENT_ADD        0
+#define DASD_HOTPLUG_EVENT_REMOVE     1
+#define DASD_HOTPLUG_EVENT_PARTCHK    2
+#define DASD_HOTPLUG_EVENT_PARTREMOVE 3
 
 #define DASD_FORMAT_INTENS_WRITE_RECZERO 0x01
 #define DASD_FORMAT_INTENS_WRITE_HOMEADR 0x02
@@ -61,7 +67,9 @@
 #include <asm/todclk.h>
 #include <asm/debug.h>
 
-/* Kernel Version Compatibility section */
+/********************************************************************************
+ * SECTION: Kernel Version Compatibility section 
+ ********************************************************************************/
 #if (LINUX_VERSION_CODE < KERNEL_VERSION(2,3,98))
 typedef struct request *request_queue_t;
 #define block_device_operations file_operations
@@ -102,6 +110,7 @@
         *q = req->next;
         req->next = NULL;
 }
+
 #else
 #define INIT_BLK_DEV(d_major,d_request_fn,d_queue_fn,d_current) \
 do { \
@@ -124,9 +133,12 @@
 {
         blkdev_dequeue_request (req);
 }
-#endif
+#endif /* (LINUX_VERSION_CODE < KERNEL_VERSION(2,3,98)) */
+
+/********************************************************************************
+ * SECTION: Type definitions
+ ********************************************************************************/
 
-/* dasd_range_t are used for dynamic device att-/detachment */
 typedef struct dasd_devreg_t {
         devreg_t devreg; /* the devreg itself */
         /* build a linked list of devregs, needed for cleanup */
@@ -153,27 +165,6 @@
 #define DASD_SENSE_BIT_2 0x20
 #define DASD_SENSE_BIT_3 0x10
 
-#define check_then_set(where,from,to) \
-do { \
-        if ((*(where)) != (from) ) { \
-                printk (KERN_ERR PRINTK_HEADER "was %d\n", *(where)); \
-                BUG(); \
-        } \
-        (*(where)) = (to); \
-} while (0)
-
-#define DASD_MESSAGE(d_loglevel,d_device,d_string,d_args...)\
-do { \
-        int d_devno = d_device->devinfo.devno; \
-        int d_irq = d_device->devinfo.irq; \
-        char *d_name = d_device->name; \
-        int d_major = MAJOR(d_device->kdev); \
-        int d_minor = MINOR(d_device->kdev); \
-        printk(d_loglevel PRINTK_HEADER \
-               "/dev/%s(%d:%d),%04x@0x%x:" \
-               d_string "\n",d_name,d_major,d_minor,d_devno,d_irq,d_args ); \
-} while(0)
-
 /* 
  * struct dasd_sizes_t
  * represents all data needed to access dasd with properly set up sectors
@@ -196,68 +187,175 @@
 	ccw_req_t *tail;
 } dasd_chanq_t;
 
-#define DASD_DEVICE_FORMAT_STRING "Device: %p"
-#define DASD_DEVICE_DEBUG_EVENT(d_level, d_device, d_str, d_data...)\
-do {\
-        if ( d_device->debug_area != NULL )\
-        debug_sprintf_event(d_device->debug_area,d_level,\
-                    DASD_DEVICE_FORMAT_STRING d_str "\n",\
-                    d_device, d_data);\
-} while(0)
-#define DASD_DEVICE_DEBUG_EXCEPTION(d_level, d_device, d_str, d_data...)\
-do {\
-        if ( d_device->debug_area != NULL )\
-        debug_sprintf_exception(d_device->debug_area,d_level,\
-                        DASD_DEVICE_FORMAT_STRING d_str "\n",\
-                        d_device, d_data);\
-} while(0)
-
-#define DASD_DRIVER_FORMAT_STRING "Driver: <[%p]>"
-#define DASD_DRIVER_DEBUG_EVENT(d_level, d_fn, d_str, d_data...)\
-do {\
-        if ( dasd_debug_area != NULL )\
-        debug_sprintf_event(dasd_debug_area, d_level,\
-                    DASD_DRIVER_FORMAT_STRING #d_fn ":" d_str "\n",\
-                    d_fn, d_data);\
-} while(0)
-#define DASD_DRIVER_DEBUG_EXCEPTION(d_level, d_fn, d_str, d_data...)\
-do {\
-        if ( dasd_debug_area != NULL )\
-        debug_sprintf_exception(dasd_debug_area, d_level,\
-                        DASD_DRIVER_FORMAT_STRING #d_fn ":" d_str "\n",\
-                        d_fn, d_data);\
+/* 
+ * struct dasd_lowmem_t 
+ * represents a queue of pages for lowmem request
+ */
+typedef struct {
+        struct list_head list;
+} dasd_lowmem_t;
+
+#define DASD_LOWMEM_PAGES 2     /* # of lowmem pages per device (min 2) */
+
+/********************************************************************************
+ * SECTION: MACROS
+ ********************************************************************************/
+
+/*
+ * CHECK_THEN_SET
+ *
+ * Change 'where' value from 'from' to 'to'.
+ ' BUG if the 'from' value doesn't match.
+ */
+#define check_then_set(where,from,to) \
+do { \
+        if ((*(where)) != (from) ) { \
+                printk (KERN_ERR PRINTK_HEADER "was %d\n", *(where)); \
+                BUG(); \
+        } \
+        (*(where)) = (to); \
+} while(0)
+
+
+/********************************************************************************
+ * SECION: MACROs for klogd and s390 debug feature (dbf)
+ ********************************************************************************/
+
+#define DBF_DEV_EVENT(d_level, d_device, d_str, d_data...) \
+do { \
+        if (d_device->debug_area != NULL) \
+                debug_sprintf_event(d_device->debug_area, \
+                                    d_level, \
+                                    d_str "\n", \
+                                    d_data); \
+} while(0)
+
+#define DBF_DEV_EXC(d_level, d_device, d_str, d_data...) \
+do { \
+        if (d_device->debug_area != NULL) \
+                debug_sprintf_exception(d_device->debug_area, \
+                                        d_level, \
+                                        d_str "\n", \
+                                        d_data); \
+} while(0)
+
+#define DBF_EVENT(d_level, d_str, d_data...)\
+do { \
+        if (dasd_debug_area != NULL) \
+                debug_sprintf_event(dasd_debug_area, \
+                                    d_level,\
+                                    d_str "\n", \
+                                    d_data); \
+} while(0)
+
+#define DBF_EXC(d_level, d_str, d_data...)\
+do { \
+        if (dasd_debug_area != NULL) \
+                debug_sprintf_exception(dasd_debug_area, \
+                                        d_level,\
+                                        d_str "\n", \
+                                        d_data); \
+} while(0)
+
+/* definition of dbf debug levels */
+#define	DBF_EMERG	0	/* system is unusable		*/
+#define	DBF_ALERT	1	/* action must be taken immediately	*/
+#define	DBF_CRIT	2	/* critical conditions		*/
+#define	DBF_ERR  	3	/* error conditions			*/
+#define	DBF_WARNING	4	/* warning conditions		*/
+#define	DBF_NOTICE	5	/* normal but significant condition	*/
+#define	DBF_INFO	6	/* informational			*/
+#define	DBF_DEBUG	6	/* debug-level messages		*/
+
+/* messages to be written via klogd and dbf */
+#define DEV_MESSAGE(d_loglevel,d_device,d_string,d_args...)\
+do { \
+        int d_devno = d_device->devinfo.devno; \
+        int d_irq = d_device->devinfo.irq; \
+        char *d_name = d_device->name; \
+        int d_major = MAJOR(d_device->kdev); \
+        int d_minor = MINOR(d_device->kdev); \
+\
+        printk(d_loglevel PRINTK_HEADER \
+               " /dev/%-7s(%3d:%3d),%04x@%02x: " \
+               d_string "\n", \
+               d_name, \
+               d_major, \
+               d_minor, \
+               d_devno, \
+               d_irq, \
+               d_args); \
+\
+        DBF_DEV_EVENT(DBF_ALERT, \
+                      d_device, \
+                      d_string, \
+                      d_args); \
+} while(0)
+
+/* general messages to be written via klogd and dbf */
+#define MESSAGE(d_loglevel,d_string,d_args...)\
+do { \
+        printk(d_loglevel PRINTK_HEADER \
+               " " d_string "\n", \
+               d_args); \
+\
+        DBF_EVENT(DBF_ALERT, \
+                  d_string, \
+                  d_args); \
+} while(0)
+
+/* general messages to be written via klogd only */
+#define MESSAGE_LOG(d_loglevel,d_string,d_args...)\
+do { \
+        printk(d_loglevel PRINTK_HEADER \
+               " " d_string "\n", \
+               d_args); \
 } while(0)
 
 struct dasd_device_t;
 struct request;
 
-/* 
- * signatures for the functions of dasd_discipline_t 
+/********************************************************************************
+ * SECTION: signatures for the functions of dasd_discipline_t 
  * make typecasts much easier
- */
-typedef ccw_req_t *(*dasd_erp_action_fn_t) (ccw_req_t * cqr);
+ ********************************************************************************/
+
+typedef int    (*dasd_ck_id_fn_t)              (s390_dev_info_t *);
+typedef int    (*dasd_ck_characteristics_fn_t) (struct dasd_device_t *);
+typedef int    (*dasd_fill_geometry_fn_t)      (struct dasd_device_t *, 
+                                                struct hd_geometry *);
+typedef int    (*dasd_do_analysis_fn_t)        (struct dasd_device_t *);
+typedef int    (*dasd_io_starter_fn_t)         (ccw_req_t *);
+typedef int    (*dasd_io_stopper_fn_t)         (ccw_req_t *);
+typedef int    (*dasd_info_fn_t)               (struct dasd_device_t *, 
+                                                dasd_information2_t *);
+typedef int    (*dasd_use_count_fn_t)          (int);
+typedef int    (*dasd_get_attrib_fn_t)         (struct dasd_device_t *, 
+                                                struct attrib_data_t *);
+typedef int    (*dasd_set_attrib_fn_t)         (struct dasd_device_t *, 
+                                                struct attrib_data_t *);
+typedef void   (*dasd_int_handler_fn_t)        (int irq, void *, 
+                                                struct pt_regs *);
+typedef void   (*dasd_dump_sense_fn_t)         (struct dasd_device_t *,
+                                                ccw_req_t *);
+typedef ccw_req_t *(*dasd_format_fn_t)         (struct dasd_device_t *, 
+                                                struct format_data_t *);
+typedef ccw_req_t *(*dasd_init_analysis_fn_t ) (struct dasd_device_t *);
+typedef ccw_req_t *(*dasd_cp_builder_fn_t)     (struct dasd_device_t *,
+                                                struct request *);
+typedef ccw_req_t *(*dasd_reserve_fn_t)        (struct dasd_device_t *);
+typedef ccw_req_t *(*dasd_release_fn_t)        (struct dasd_device_t *);
+typedef ccw_req_t *(*dasd_steal_lock_fn_t)     (struct dasd_device_t *);
+typedef ccw_req_t *(*dasd_merge_cp_fn_t)       (struct dasd_device_t *);
+typedef ccw_req_t *(*dasd_erp_action_fn_t)     (ccw_req_t * cqr);
 typedef ccw_req_t *(*dasd_erp_postaction_fn_t) (ccw_req_t * cqr);
+typedef ccw_req_t *(*dasd_read_stats_fn_t)     (struct dasd_device_t *);
 
-typedef int (*dasd_ck_id_fn_t) (s390_dev_info_t *);
-typedef int (*dasd_ck_characteristics_fn_t) (struct dasd_device_t *);
-typedef int (*dasd_fill_geometry_fn_t) (struct dasd_device_t *, struct hd_geometry *);
-typedef ccw_req_t *(*dasd_format_fn_t) (struct dasd_device_t *, struct format_data_t *);
-typedef ccw_req_t *(*dasd_init_analysis_fn_t) (struct dasd_device_t *);
-typedef int (*dasd_do_analysis_fn_t) (struct dasd_device_t *);
-typedef int (*dasd_io_starter_fn_t) (ccw_req_t *);
-typedef int (*dasd_io_stopper_fn_t) (ccw_req_t *);
-typedef void (*dasd_int_handler_fn_t)(int irq, void *, struct pt_regs *);
-typedef dasd_era_t (*dasd_error_examine_fn_t) (ccw_req_t *, devstat_t * stat);
-typedef dasd_erp_action_fn_t (*dasd_error_analyse_fn_t) (ccw_req_t *);
-typedef dasd_erp_postaction_fn_t (*dasd_erp_analyse_fn_t) (ccw_req_t *);
-typedef ccw_req_t *(*dasd_cp_builder_fn_t)(struct dasd_device_t *,struct request *);
-typedef char *(*dasd_dump_sense_fn_t)(struct dasd_device_t *,ccw_req_t *);
-typedef ccw_req_t *(*dasd_reserve_fn_t)(struct dasd_device_t *);
-typedef ccw_req_t *(*dasd_release_fn_t)(struct dasd_device_t *);
-typedef ccw_req_t *(*dasd_steal_lock_fn_t)(struct dasd_device_t *);
-typedef ccw_req_t *(*dasd_merge_cp_fn_t)(struct dasd_device_t *);
-typedef int (*dasd_info_fn_t) (struct dasd_device_t *, dasd_information_t *);
-typedef int (*dasd_use_count_fn_t) (int);
+typedef dasd_rssd_perf_stats_t * (*dasd_ret_stats_fn_t)     (ccw_req_t *);
+typedef dasd_era_t               (*dasd_error_examine_fn_t) (ccw_req_t *, 
+                                                             devstat_t * stat);
+typedef dasd_erp_action_fn_t     (*dasd_error_analyse_fn_t) (ccw_req_t *);
+typedef dasd_erp_postaction_fn_t (*dasd_erp_analyse_fn_t)   (ccw_req_t *);
 
 /*
  * the dasd_discipline_t is
@@ -270,31 +368,32 @@
 	char ebcname[8]; /* a name used for tagging and printks */
         char name[8];		/* a name used for tagging and printks */
 	int max_blocks;	/* maximum number of blocks to be chained */
-	dasd_ck_id_fn_t id_check;	/* to check sense data */
-	dasd_ck_characteristics_fn_t check_characteristics;	/* to check the characteristics */
-	dasd_init_analysis_fn_t init_analysis;	/* to start the analysis of the volume */
-	dasd_do_analysis_fn_t do_analysis;	/* to complete the analysis of the volume */
-	dasd_fill_geometry_fn_t fill_geometry;	/* to set up hd_geometry */
-	dasd_io_starter_fn_t start_IO;
-	dasd_io_stopper_fn_t term_IO;
-        dasd_format_fn_t format_device;		/* to format the device */
-	dasd_error_examine_fn_t examine_error;
-	dasd_error_analyse_fn_t erp_action;
-	dasd_erp_analyse_fn_t erp_postaction;
-        dasd_cp_builder_fn_t build_cp_from_req;
-        dasd_dump_sense_fn_t dump_sense;
-        dasd_int_handler_fn_t int_handler;
-        dasd_reserve_fn_t reserve;
-        dasd_release_fn_t release;
-        dasd_steal_lock_fn_t steal_lock;
-        dasd_merge_cp_fn_t merge_cp;
-        dasd_info_fn_t fill_info;
+	dasd_ck_id_fn_t              id_check;	            /* check sense data */
+	dasd_ck_characteristics_fn_t check_characteristics; /* check the characteristics */
+	dasd_init_analysis_fn_t      init_analysis;	    /* start the analysis of the volume */
+	dasd_do_analysis_fn_t        do_analysis;	    /* complete the analysis of the volume */
+	dasd_fill_geometry_fn_t      fill_geometry;	    /* set up hd_geometry */
+	dasd_io_starter_fn_t         start_IO;                 
+	dasd_io_stopper_fn_t         term_IO;                  
+        dasd_format_fn_t             format_device;	    /* format the device */
+	dasd_error_examine_fn_t      examine_error;
+	dasd_error_analyse_fn_t      erp_action;
+	dasd_erp_analyse_fn_t        erp_postaction;
+        dasd_cp_builder_fn_t         build_cp_from_req;
+        dasd_dump_sense_fn_t         dump_sense;
+        dasd_int_handler_fn_t        int_handler;
+        dasd_reserve_fn_t            reserve;
+        dasd_release_fn_t            release;
+        dasd_steal_lock_fn_t         steal_lock;
+        dasd_merge_cp_fn_t           merge_cp;
+        dasd_info_fn_t               fill_info;
+        dasd_read_stats_fn_t         read_stats;
+        dasd_ret_stats_fn_t          ret_stats;             /* return performance statistics */
+        dasd_get_attrib_fn_t         get_attrib;            /* get attributes (cache operations */ 
+        dasd_set_attrib_fn_t         set_attrib;            /* set attributes (cache operations */ 
 	struct list_head list;	/* used for list of disciplines */
 } dasd_discipline_t;
 
-#define DASD_DEFAULT_FEATURES 0
-#define DASD_FEATURE_READONLY 1
-
 /* dasd_range_t are used for ordering the DASD devices */
 typedef struct dasd_range_t {
 	unsigned int from;	/* first DASD in range */
@@ -326,7 +425,9 @@
 	struct dasd_chanq_t queue;
         wait_queue_head_t wait_q;
         request_queue_t *request_queue;
-        struct timer_list timer;      
+        struct timer_list timer;             /* used for start_IO */
+        struct timer_list late_timer;        /* to get late devices online */  
+        struct timer_list blocking_timer;    /* used for ERP */
 	devstat_t dev_status; /* needed ONLY!! for request_irq */
         dasd_sizes_t sizes;
         char name[16]; /* The name of the device in /dev */
@@ -340,35 +441,41 @@
         dasd_profile_info_t profile;
         ccw_req_t *init_cqr;
         atomic_t plugged;
-        void* lowmem_cqr;
-        void* lowmem_ccws;
-        void* lowmem_idals;
-        void* lowmem_idal_ptr;
+        int stopped;                         /* device (do_IO) was stopped */
+        struct list_head lowmem_pool;
 }  dasd_device_t;
 
-int dasd_init (void);
-void dasd_discipline_add(dasd_discipline_t *);
-void dasd_discipline_del(dasd_discipline_t *);
-int dasd_start_IO (ccw_req_t *);
-int dasd_term_IO (ccw_req_t *);
-void dasd_int_handler (int , void *, struct pt_regs *);
-ccw_req_t *dasd_default_erp_action (ccw_req_t *);
-ccw_req_t *dasd_default_erp_postaction (ccw_req_t *);
-inline void dasd_chanq_deq (dasd_chanq_t *, ccw_req_t *);
-inline void dasd_chanq_enq (dasd_chanq_t *, ccw_req_t *);
-inline void dasd_chanq_enq_head (dasd_chanq_t *, ccw_req_t *);
-ccw_req_t *dasd_alloc_request (char *, int, int, dasd_device_t *);
-void dasd_free_request (ccw_req_t *, dasd_device_t *);
-int dasd_oper_handler (int irq, devreg_t * devreg);
-void dasd_schedule_bh (dasd_device_t *);
-int dasd_sleep_on_req(ccw_req_t*);
-int  dasd_set_normalized_cda ( ccw1_t * cp, unsigned long address, ccw_req_t* request, dasd_device_t* device );
-dasd_device_t * dasd_device_from_kdev (kdev_t kdev);
+/* reasons why device (do_IO) was stopped */
+#define DASD_STOPPED_NOT_ACC 1         /* not accessible */
+#define DASD_STOPPED_PENDING 2         /* long busy */
+
+
+int  dasd_init               (void);
+void dasd_discipline_add     (dasd_discipline_t *);
+void dasd_discipline_del     (dasd_discipline_t *);
+int  dasd_start_IO           (ccw_req_t *);
+int  dasd_term_IO            (ccw_req_t *);
+void dasd_int_handler        (int , void *, struct pt_regs *);
+void dasd_free_request       (ccw_req_t *, dasd_device_t *);
+int  dasd_oper_handler       (int irq, devreg_t * devreg);
+void dasd_schedule_bh        (dasd_device_t *);
+void dasd_schedule_bh_timed  (unsigned long);
+int  dasd_sleep_on_req       (ccw_req_t*);
+int  dasd_set_normalized_cda (ccw1_t * cp, unsigned long address, 
+                              ccw_req_t* request, 
+                              dasd_device_t* device );
+ccw_req_t *     dasd_default_erp_action     (ccw_req_t *);
+ccw_req_t *     dasd_default_erp_postaction (ccw_req_t *);
+inline void     dasd_chanq_deq              (dasd_chanq_t *, ccw_req_t *);
+inline void     dasd_chanq_enq              (dasd_chanq_t *, ccw_req_t *);
+inline void     dasd_chanq_enq_head         (dasd_chanq_t *, ccw_req_t *);
+ccw_req_t *     dasd_alloc_request          (char *, int, int, dasd_device_t *);
+dasd_device_t * dasd_device_from_kdev       (kdev_t kdev);
 
 extern debug_info_t *dasd_debug_area;
 extern int (*genhd_dasd_name) (char *, int, int, struct gendisk *);
 extern int (*genhd_dasd_ioctl) (struct inode *inp, struct file *filp,
-                            unsigned int no, unsigned long data);
+                                unsigned int no, unsigned long data);
 
 #endif /* __KERNEL__ */
 
Index: drivers/s390/block/xpram.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/s390/block/xpram.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/s390/block/xpram.c	22 Jul 2004 19:49:59 -0000	1.1
+++ drivers/s390/block/xpram.c	4 Aug 2004 01:29:28 -0000	1.2
@@ -184,9 +184,7 @@
 		 "All devices with size 0 equally partition the "
 		 "remaining space on the expanded strorage not "
 		 "claimed by explicit sizes\n");
-#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,12))
-MODULE_LICENSE ("GPL");
-#endif
+MODULE_LICENSE("GPL");
 
 
 /* The following items are obtained through kmalloc() in init_module() */
@@ -273,7 +271,7 @@
 		return XPRAM_INVALF;
 	if ( (**strptr == '0') 
 	     && ( (*((*strptr)+1) == 'x') || (*((*strptr) +1) == 'X') ) 
-	     && isdigit(*((*strptr)+3)) ) {
+	     && isxdigit(*((*strptr)+2)) ) {
 		*strptr=(*strptr)+2;
 		return XPRAM_HEXF;
 	} else return XPRAM_DECF;
Index: drivers/s390/char/con3215.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/s390/char/con3215.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/s390/char/con3215.c	22 Jul 2004 19:49:59 -0000	1.1
+++ drivers/s390/char/con3215.c	4 Aug 2004 01:29:28 -0000	1.2
@@ -462,30 +462,35 @@
                 if ((raw = req->info) == NULL)
                         return;              /* That shouldn't happen ... */
 		if (req->type == RAW3215_READ && raw->tty != NULL) {
-			char *cchar;
+			unsigned int cchar;
 
 			tty = raw->tty;
-                        count = 160 - req->residual;
-                        if (MACHINE_IS_P390) {
-                                slen = strnlen(raw->inbuf, RAW3215_INBUF_SIZE);
-                                if (count > slen)
-                                        count = slen;
-                        } else
+			count = 160 - req->residual;
+			if (MACHINE_IS_P390) {
+				slen = strnlen(raw->inbuf, RAW3215_INBUF_SIZE);
+				if (count > slen)
+					count = slen;
+			} else
 			if (count >= TTY_FLIPBUF_SIZE - tty->flip.count)
 				count = TTY_FLIPBUF_SIZE - tty->flip.count - 1;
 			EBCASC(raw->inbuf, count);
-			if ((cchar = ctrlchar_handle(raw->inbuf, count, tty))) {
-				if (cchar == (char *)-1)
-					goto in_out;
+			cchar = ctrlchar_handle(raw->inbuf, count, tty);
+			switch (cchar & CTRLCHAR_MASK) {
+			case CTRLCHAR_SYSRQ:
+				break;
+
+			case CTRLCHAR_CTRL:
 				tty->flip.count++;
 				*tty->flip.flag_buf_ptr++ = TTY_NORMAL;
-				*tty->flip.char_buf_ptr++ = *cchar;
+				*tty->flip.char_buf_ptr++ = cchar;
 				tty_flip_buffer_push(raw->tty);
-			} else {
+				break;
+
+			case CTRLCHAR_NONE:
 				memcpy(tty->flip.char_buf_ptr,
 				       raw->inbuf, count);
 				if (count < 2 ||
-				    (strncmp(raw->inbuf+count-2, "^n", 2) ||
+				    (strncmp(raw->inbuf+count-2, "^n", 2) && 
 				    strncmp(raw->inbuf+count-2, "\252n", 2)) ) {
 					/* don't add the auto \n */
 					tty->flip.char_buf_ptr[count] = '\n';
@@ -498,12 +503,12 @@
 				tty->flip.flag_buf_ptr += count;
 				tty->flip.count += count;
 				tty_flip_buffer_push(raw->tty);
+				break;
 			}
 		} else if (req->type == RAW3215_WRITE) {
 			raw->count -= req->len;
                         raw->written -= req->len;
 		} 
-in_out:
 		raw->flags &= ~RAW3215_WORKING;
 		raw3215_free_req(req);
 		/* check for empty wait */
@@ -823,7 +828,8 @@
  *  The console structure for the 3215 console
  */
 static struct console con3215 = {
-	name:		"tty3215",
+	name:		"ttyS",
+	index:		0,
 	write:		con3215_write,
 	device:		con3215_device,
 	unblank:	con3215_unblank,
@@ -1120,6 +1126,9 @@
  */
 void __init tty3215_init(void)
 {
+	/* Don't bother registering the tty if we already skipped the console */
+	if (!CONSOLE_IS_3215)
+		return;
 	/*
 	 * Initialize the tty_driver structure
 	 * Entries in tty3215_driver that are NOT initialized:
Index: drivers/s390/char/ctrlchar.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/s390/char/ctrlchar.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/s390/char/ctrlchar.c	22 Jul 2004 19:49:59 -0000	1.1
+++ drivers/s390/char/ctrlchar.c	4 Aug 2004 01:29:28 -0000	1.2
@@ -8,32 +8,30 @@
  */
 
 #include <linux/config.h>
-#include <linux/types.h>
-#include <linux/tty.h>
-#include <linux/interrupt.h>
-
+#include <linux/stddef.h>
 #include <linux/sysrq.h>
+#include <linux/ctype.h>
+#include <linux/interrupt.h>
 
-#include <asm/io.h>
-#include <asm/uaccess.h>
-#include <asm/delay.h>
-#include <asm/cpcmd.h>
-#include <asm/irq.h>
+#include "ctrlchar.h"
 
 #ifdef CONFIG_MAGIC_SYSRQ
 static int ctrlchar_sysrq_key;
 static struct tq_struct ctrlchar_tq;
 
 static void
-ctrlchar_handle_sysrq(struct tty_struct *tty) {
-	handle_sysrq(ctrlchar_sysrq_key, NULL, NULL, tty);
+ctrlchar_handle_sysrq(void *tty)
+{
+	handle_sysrq(ctrlchar_sysrq_key, NULL, NULL, (struct tty_struct*) tty);
 }
 #endif
 
-void ctrlchar_init(void) {
+void
+ctrlchar_init(void)
+{
 #ifdef CONFIG_MAGIC_SYSRQ
 	static int init_done = 0;
-
+ 
 	if (init_done++)
 		return;
 	INIT_LIST_HEAD(&ctrlchar_tq.list);
@@ -48,49 +46,43 @@
  * @param buf Console input buffer.
  * @param len Length of valid data in buffer.
  * @param tty The tty struct for this console.
- * @return NULL, if nothing matched, (char *)-1, if buffer contents
- *         should be ignored, otherwise pointer to char to be inserted.
+ * @return CTRLCHAR_NONE, if nothing matched,
+ *         CTRLCHAR_SYSRQ, if sysrq was encountered
+ *         otherwise char to be inserted logically or'ed
+ *         with CTRLCHAR_CTRL
  */
-char *ctrlchar_handle(const char *buf, int len, struct tty_struct *tty) {
-
-	static char ret;
-
+unsigned int
+ctrlchar_handle(const unsigned char *buf, int len, struct tty_struct *tty)
+{
 	if ((len < 2) || (len > 3))
-		return NULL;
+		return CTRLCHAR_NONE;
+
 	/* hat is 0xb1 in codepage 037 (US etc.) and thus */
 	/* converted to 0x5e in ascii ('^') */
 	if ((buf[0] != '^') && (buf[0] != '\252'))
-		return NULL;
-	switch (buf[1]) {
+		return CTRLCHAR_NONE;
+
 #ifdef CONFIG_MAGIC_SYSRQ
-		case '-':
-			if (len == 3) {
-				ctrlchar_sysrq_key = buf[2];
-				ctrlchar_tq.data = tty;
-				queue_task(&ctrlchar_tq, &tq_immediate);
-				mark_bh(IMMEDIATE_BH);
-				return (char *)-1;
-			}
-			break;
+	/* racy */
+	if (len == 3 && buf[1] == '-') {
+		ctrlchar_sysrq_key = buf[2];
+		ctrlchar_tq.data = tty;
+		queue_task(&ctrlchar_tq, &tq_immediate);
+		mark_bh(IMMEDIATE_BH);
+		return CTRLCHAR_SYSRQ;
+	}
 #endif
-		case 'c':
-			if (len == 2) {
-				ret = INTR_CHAR(tty);
-				return &ret;
-			}
-			break;
-		case 'd':
-			if (len == 2) {
-				ret = EOF_CHAR(tty);
-				return &ret;
-			}
-			break;
-		case 'z':
-			if (len == 2) {
-				ret = SUSP_CHAR(tty);
-				return &ret;
-			}
-			break;
+
+	if (len != 2)
+		return CTRLCHAR_NONE;
+
+	switch (tolower(buf[1])) {
+	case 'c':
+		return INTR_CHAR(tty) | CTRLCHAR_CTRL;
+	case 'd':
+		return EOF_CHAR(tty)  | CTRLCHAR_CTRL;
+	case 'z':
+		return SUSP_CHAR(tty) | CTRLCHAR_CTRL;
 	}
-	return NULL;
+	return CTRLCHAR_NONE;
 }
Index: drivers/s390/char/ctrlchar.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/s390/char/ctrlchar.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/s390/char/ctrlchar.h	22 Jul 2004 19:49:59 -0000	1.1
+++ drivers/s390/char/ctrlchar.h	4 Aug 2004 01:29:28 -0000	1.2
@@ -7,9 +7,15 @@
  *
  */
 
-#include <linux/config.h>
-#include <linux/types.h>
 #include <linux/tty.h>
 
+extern unsigned int
+ctrlchar_handle(const unsigned char *buf, int len, struct tty_struct *tty);
 extern void ctrlchar_init(void);
-extern char *ctrlchar_handle(const char *buf, int len, struct tty_struct *tty);
+
+
+#define CTRLCHAR_NONE  (1 << 8)
+#define CTRLCHAR_CTRL  (2 << 8)
+#define CTRLCHAR_SYSRQ (3 << 8)
+
+#define CTRLCHAR_MASK (~0xffu)
Index: drivers/s390/misc/chandev.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/s390/misc/chandev.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/s390/misc/chandev.c	22 Jul 2004 19:49:59 -0000	1.1
+++ drivers/s390/misc/chandev.c	4 Aug 2004 01:29:29 -0000	1.2
@@ -2470,6 +2470,7 @@
 					goto BadArgs;
 					
 				}
+				break;
 			case del_auto_msck_stridx*stridx_mult:
 			case (del_auto_msck_stridx*stridx_mult)|iscomma:
 				switch(ints[0])
@@ -2482,6 +2483,7 @@
 				default:
 					goto BadArgs;
 				}
+				break;
 			case del_noauto_stridx*stridx_mult:
 				chandev_free_all_list((list **)&chandev_noauto_head);
 				break;
Index: drivers/s390/net/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/s390/net/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/s390/net/Makefile	22 Jul 2004 19:49:58 -0000	1.1
+++ drivers/s390/net/Makefile	4 Aug 2004 01:29:29 -0000	1.2
@@ -12,6 +12,9 @@
 obj-$(CONFIG_IUCV) += iucv.o fsm.o
 obj-$(CONFIG_CTC) += ctc.o fsm.o
 obj-$(CONFIG_IUCV) += netiucv.o
+obj-$(CONFIG_C7000) += c7000.o
+obj-$(CONFIG_QETH) += qeth.o
+export-objs += qeth.o
 
 include $(TOPDIR)/Rules.make
 
